<?php
/*
Plugin Name: Move Records Here
Description: Allow users to move groups of selected records in manually sorted record lists.
Version: 1.00
Requires at least: 3.10
*/

$GLOBALS['MRH_LINK_NAME'] = 'Move record(s) here';  // the link name

// DON'T UPDATE ANYTHING BELOW THIS LINE
require_once "moveRecordsHere.js.php";

addAction('admin_head', 'moveRecordsHere_addJavascript', null, 0);
addAction('section_unknownAction', 'moveRecordsHere_updateRecordOrder', null, 1);
addFilter('listRow_actionLinks', 'moveRecordsHere_addLink', null, 3);
addFilter('list_advancedCommands', 'moveRecordsHere_addAdvancedOption', null, 1);

//
function moveRecordsHere_addAdvancedOption($labelsToValues) {
  global $schema;
  if (!@$schema['dragSortOrder'])         { return $labelsToValues; } // skip sections without dragSortOrder field
  if (@$schema['_disableAdd'] == '1')     { return $labelsToValues; } // skip sections with add disabled
  if (@$schema['menuType'] == 'category') { return $labelsToValues; } // skip sections with menuType category (not tested)

  $labelsToValues['Move Records'] = 'moveRecordsHere_updateRecordOrder';
  return $labelsToValues;
}

// add "move record here" link
function moveRecordsHere_addLink($actionLinks, $tableName, $record) {
  global $schema;
  if (!@$schema['dragSortOrder'])         { return $actionLinks; } // skip sections without dragSortOrder field
  if (@$schema['_disableAdd'] == '1')     { return $actionLinks; } // skip sections with add disabled
  if (@$schema['menuType'] == 'category') { return $actionLinks; } // skip sections with menuType category (not tested)
  // target record 
  $targetRecordNum = $record['num'];
    
  // create link
  $actionLinks  .= "<br><a href=\"#\" data-actionlink-type=\"mrh\" id=\"$targetRecordNum\" class=\"hidden\">{$GLOBALS['MRH_LINK_NAME']}</a>";

  //
  return $actionLinks;
}

// 
function moveRecordsHere_updateRecordOrder($tableName) {
  global $schema;
  if (!@$schema['dragSortOrder'])         { return; }
  if (@$schema['menuType'] == 'category') { return; }

  // error checking - get check record numbers
  if (!@$schema)                      { die("schema not defined!"); }
  if (!@$_REQUEST['selectedRecords']) { die(t("No records were selected!")); }
  else {
    $recordNums      = array_map('intval', $_REQUEST['selectedRecords']);
    $recordNumsAsCSV = implode(',', $recordNums);
    $recordNumsCount = count($recordNums); // count selected records
    
    $targetRecordNum = intval($_REQUEST['fieldTargetRecord']);
    $targetRecord    = mysql_get($tableName, $targetRecordNum);
    $targetRecordOrigDSO = $targetRecord['dragSortOrder'];

    $firstBatchRecords = mysql_select($tableName, "`num` NOT IN($recordNumsAsCSV) AND `dragSortOrder` <= '$targetRecordOrigDSO'");
    $firstBatchRecordsCount = count($firstBatchRecords);
      
    // re-order records
    $tableNameWithPrefix = getTableNameWithPrefix($tableName);
    // query set 1
    $query1 = "SET @count = 0";
    $query2 = "UPDATE `$tableNameWithPrefix` SET `dragSortOrder` = (SELECT @count := @count + 10) WHERE `num` NOT IN($recordNumsAsCSV) AND `dragSortOrder` <= '$targetRecordOrigDSO' ORDER BY dragSortOrder";
    mysqli()->query($query1) or die("MySQL Error: ". htmlencode(mysqli()->error) . "\n");
    mysqli()->query($query2) or die("MySQL Error: ". htmlencode(mysqli()->error) . "\n");
    
    // query set 2
    $selectedNumsStartCount = ($firstBatchRecordsCount * 10);
    foreach($recordNums as $recordNum) {  
      $query3 = "SET @count = $selectedNumsStartCount";
      $query4 = "UPDATE `$tableNameWithPrefix` SET `dragSortOrder` = (SELECT @count := @count + 10) WHERE `num` = '$recordNum'";
      mysqli()->query($query3) or die("MySQL Error: ". htmlencode(mysqli()->error) . "\n");
      mysqli()->query($query4) or die("MySQL Error: ". htmlencode(mysqli()->error) . "\n");
      $selectedNumsStartCount = ($selectedNumsStartCount + 10);
    }
      
    // query set 3
    $secondBatchStartCount = (($recordNumsCount + $firstBatchRecordsCount) * 10);
    $query5 = "SET @count = $secondBatchStartCount";
    $query6 = "UPDATE `$tableNameWithPrefix` SET `dragSortOrder` = (SELECT @count := @count + 10) WHERE `num` NOT IN($recordNumsAsCSV) AND `dragSortOrder` >  '$targetRecordOrigDSO' ORDER BY dragSortOrder";
    mysqli()->query($query5) or die("MySQL Error: ". htmlencode(mysqli()->error) . "\n");
    mysqli()->query($query6) or die("MySQL Error: ". htmlencode(mysqli()->error) . "\n");
       
    //
    redirectBrowserToURL('?menu='.$tableName);
  }

}

// eof